<template>
  <section class="AppDeploy">
    <ai-list>
      <ai-title slot="title" title="部署发布" isShowBottomBorder/>
      <template #content>
        <ai-search-bar>
          <template #left>
            <el-button type="primary" icon="iconfont iconAdd" @click="dialog=true">增加</el-button>
          </template>
          <template #right>
            <el-input size="small" placeholder="搜索项目/系统" v-model="search.name" clearable
                      @change="page.current=1,getTableData()"/>
          </template>
        </ai-search-bar>
        <ai-table :tableData="tableData" :total="page.total" :current.sync="page.current" :size.sync="page.size"
                  @getList="getTableData" :col-configs="colConfigs" :dict="dict">
          <el-table-column type="expand" slot="expand">
            <template slot-scope="{row}">
              <ai-wrapper>
                <ai-info-item labelWidth="200px" v-for="op in desConfigs" :key="op.prop" :value="row[op.prop]"
                              v-bind="op"/>
              </ai-wrapper>
            </template>
          </el-table-column>
          <el-table-column slot="process" label="打包进度">
            <template slot-scope="{row}">
              <span v-if="row.count==0" v-text="getProcessMsg(row)"/>
              <el-progress v-else :percentage="row.count"/>
            </template>
          </el-table-column>
          <el-table-column slot="options" label="操作" fixed="right" align="center" width="300">
            <template slot-scope="{row}">
              <el-button type="text" @click="handleEdit(row)">编辑</el-button>
              <el-button type="text" @click="handleDelete(row.id)">删除</el-button>
              <el-button type="text" @click="handleZip(row)" v-if="row.count==0">打包更新</el-button>
              <el-button type="text" @click="handleCancelZip(row)" v-else>停止打包</el-button>
              <el-button type="text" v-if="row.target" @click="handleDownload(row)">下载</el-button>
            </template>
          </el-table-column>
        </ai-table>
      </template>
    </ai-list>
    <ai-dialog :visible.sync="dialog" title="部署任务设置" width="700px" @close="form={}" @onConfirm="submit">
      <el-form ref="DialogForm" :model="form" size="small" label-width="100px" :rules="rules">
        <el-form-item label="项目/系统" prop="name">
          <el-input v-model="form.name" clearable placeholder="请输入"/>
        </el-form-item>
        <el-form-item label="系统类型" prop="type">
          <ai-select v-model="form.type" :selectList="dict.getDict('systemType')"/>
        </el-form-item>
        <el-form-item label="打包脚本" prop="libShell">
          <el-input v-model="form.libShell" clearable placeholder="请输入"/>
        </el-form-item>
        <el-form-item label="更新脚本" prop="updateShell">
          <el-input v-model="form.updateShell" clearable placeholder="请输入"/>
        </el-form-item>
        <el-form-item label="项目URL" prop="webUrl">
          <el-input v-model="form.webUrl" clearable placeholder="请输入"/>
        </el-form-item>
        <el-form-item label="打包地址" prop="webUrl">
          <el-input v-model="form.zipPath" clearable placeholder="请输入"/>
        </el-form-item>
        <el-form-item label="nginx路径" prop="target">
          <el-input v-model="form.target" clearable placeholder="请输入"/>
        </el-form-item>
        <el-form-item label="node版本" prop="nodeVersion">
          <el-input v-model="form.nodeVersion" clearable placeholder="请输入"/>
        </el-form-item>
      </el-form>
    </ai-dialog>
  </section>
</template>

<script>
import {mapState} from "vuex";

export default {
  name: "AppDeploy",
  label: "部署发布",
  props: {
    instance: Function,
    dict: Object,
    permissions: Function
  },
  computed: {
    ...mapState(['user']),
    desConfigs() {
      let isLine = true
      return [
        {prop: "libShell", label: "打包脚本", width: 100},
        {prop: "updateShell", label: "更新脚本", width: 100},
        {prop: "zipPath", label: "打包地址", width: 100, isLine},
        {prop: "target", label: "nginx路径", width: 100, isLine},
        {prop: "webUrl", label: "项目URL", width: 100},
        {prop: "nodeVersion", label: "node打包版本", width: 100},
      ]
    },
  },
  data() {
    return {
      search: {name: ""},
      page: {current: 1, size: 10, total: 0},
      tableData: [],
      colConfigs: [
        {slot: "expand"},
        {label: "项目/系统名称", prop: "name", width: 200},
        {label: "系统类型", prop: "type", dict: "systemType", width: 80},
        {label: "nginx路径", prop: "target"},
        {slot: "process"},
        {slot: "options"}
      ],
      dialog: false,
      form: {},
      rules: {
        name: {required: true, message: "请输入项目/系统名称"},
      },
      timer: {}
    }
  },
  methods: {
    getTableData() {
      this.instance.post("/node/autodeploy/list", null, {
        params: {...this.page, ...this.search}
      }).then(res => {
        if (res?.data) {
          this.tableData = res.data?.records.map(e => ({...e, count: 0}))
          this.page.total = res.data.total
        }
      })
    },
    handleDownload(row) {
      let {id} = row
      this.instance.post("/node/autodeploy/download", null, {
        params: {id},
        responseType: "blob"
      }).then(res => {
        if (res?.code == 1) {
          this.$message.error(res.err)
        } else {
          const link = document.createElement('a')
          let blob = new Blob([res], {type: 'application/zip'})
          link.style.display = 'none'
          link.href = URL.createObjectURL(blob)
          link.setAttribute('download', row.name + '.zip')
          document.body.appendChild(link)
          link.click()
          document.body.removeChild(link)
        }
      })
    },
    handleZip(row) {
      let {id} = row, {timer} = this
      this.instance.post("/node/autodeploy/getZip", null, {
        params: {id}
      }).then(res => {
        if (res?.code == 0) {
          row.count = 1
          timer[id] = setInterval(() => {
            if (row.count >= 100) {
              clearInterval(timer[id])
              row.count = 0
              this.$message.error("打包失败!")
            } else if (row.count <= 10 && row.target) {
              row.count++
            } else this.handleConfirmZip(row).then(v => {
              if (v.error) {
                clearInterval(timer[id])
                this.$message.error("打包失败!")
                this.refreshRow(row, v)
                row.count = 0
              } else if (v.download) {
                clearInterval(timer[id])
                this.refreshRow(row, v)
                row.count = 0
              } else row.count++
            })
          }, 3000)
        }
      })
    },
    refreshRow(row, v) {
      row.error = v.error
      row.download = v.download
      row.zipTime = v.zipTime
    },
    handleCancelZip(row) {
      let {id} = row
      return this.instance.post("/node/autodeploy/cancelZip", null, {
        params: {id}
      }).then(res => {
        if (res?.code == 0) {
          clearInterval(this.timer[id])
          row.count = 0
          this.handleConfirmZip(row).then(v => this.refreshRow(row, v))
        }
      })
    },
    handleEdit(row) {
      this.form = JSON.parse(JSON.stringify(row))
      this.dialog = true
    },
    submit() {
      this.$refs.DialogForm.validate(v => {
        if (v) {
          this.instance.post("/node/autodeploy/addOrUpdate", this.form).then(res => {
            if (res?.code == 0) {
              this.$message.success("提交成功")
              this.getTableData()
              this.dialog = false
            }
          })
        }
      })
    },
    handleDelete(ids) {
      this.$confirm("是否要删除该项目/系统?").then(() => {
        this.instance.post("/node/autodeploy/delete", null, {
          params: {ids}
        }).then(res => {
          if (res?.code == 0) {
            this.$message.success("删除成功")
            this.getTableData()
          }
        })
      }).catch(() => 0)
    },
    handleConfirmZip(row) {
      let {id} = row
      return this.instance.post("/node/autodeploy/confirmZip", null, {
        params: {id}
      }).then(res => {
        if (res?.code == 0) return res.data
      })
    },
    getProcessMsg(row) {
      let time = row.zipTime ? this.$moment(row.download).diff(row.zipTime, 's', true) : ""
      return row.error || (row.download ? `最近打包时间:${row.download}(用时:${time}秒)` :
          row.zipTime ? `正在打包,开始于:${row.zipTime}` : `暂无打包`)
    }
  },
  created() {
    this.dict.load("systemType")
    this.getTableData()
  },
  beforeDestroy() {
    Object.values(this.timer).map(t => clearInterval(t))
  }
}
</script>

<style lang="scss" scoped>
.AppDeploy {
  height: 100%;

  ::v-deep.textRight {
    direction: rtl;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
  }
}
</style>
